#!/bin/bash

set -e

PROJECT_DIR=$( cd "$(dirname "$0")" ; pwd -P )

# Use environment setup from .env (use .env.default as a template)
. "${PROJECT_DIR}/.env"

# Check that environment is properly set
if [[ "$UNITY_HOME" == "" ]]; then
    echo "$0: Error empty UNITY_HOME. In your .env file, add 'export UNITY_HOME=<path_to_your_unity>'"
    exit 1
fi

if [[ "$MONO_HOME" == "" ]]; then
    echo "$0: Error empty MONO_HOME. In your .env file, add 'export MONO_HOME=<path_to_mono>'"
    exit 1
fi

if [[ "${YOUR_PROJECT_DTO}" == "" ]]; then
    echo "$0: Error empty YOUR_PROJECT_DTO. In your .env file, add 'export YOUR_PROJECT_DTO=<your_projects_DTO_folder_name>'"
    exit 1
fi

if [[ "${UNITY_PROJECT_FOLDER}" == "" ]]; then
    echo "$0: Error empty UNITY_PROJECT_FOLDER. In your .env file, add 'export UNITY_PROJECT_FOLDER=<your_projects_folder_name>'"
    exit 1
fi

# Do the actual job
$MONO_HOME/cli "${PROJECT_DIR}/SerializerGenerator/bin/Release/SerializerGenerator.exe" -i \
    "${PROJECT_DIR}/ScalableServerDTO/bin/Release/ScalableServerDTO.dll" "${PROJECT_DIR}/${YOUR_PROJECT_DTO}/bin/Release/${YOUR_PROJECT_DTO}.dll"

cp "${PROJECT_DIR}/ScalableServerDTO/bin/Release/ScalableServerDTO.dll" "${PROJECT_DIR}/${UNITY_PROJECT_FOLDER}/Assets/Plugins/AsmodeeNet/"
cp "${PROJECT_DIR}/${YOUR_PROJECT_DTO}/bin/Release/${YOUR_PROJECT_DTO}.dll" "${PROJECT_DIR}/${UNITY_PROJECT_FOLDER}/Assets/Plugins/AsmodeeNet/"
mv AsmodeeNetSerializer.dll "${PROJECT_DIR}/${UNITY_PROJECT_FOLDER}/Assets/Plugins/AsmodeeNet/"
